import React from 'react';
import styles from './index.less';
import { TagProps } from '../detailInterface';

export default function TagList(props: TagProps) {
    const { value, maxTagCount = 2, options } = props;
    if (!Array.isArray(value) || value.length === 0) return null;

    let newArr = value.slice(0, maxTagCount).filter((item) => item.value);
    return (
        <div className={styles.tagList}>
            {newArr.map((item, index) => {
                let color = '';
                if (options && Array.isArray(options) && options.length > 0) {
                    const obj = options.find((ls) => ls.id === item.value) || {};
                    color = obj.color || '';
                }
                if (value.length === 1) {
                    return (
                        <div
                            className={styles.item}
                            style={{ background: `#${color || 'E9EEF9'}` }}
                            key={item.value + index}
                        >
                            <span className={styles.itemBgTxt}>{item.text}</span>
                        </div>
                    );
                }
                return (
                    <div
                        className={styles.item}
                        style={{ background: `#${color || 'E9EEF9'}` }}
                        key={item.value + index}
                    >
                        <span className={styles.itemBgTxt}>{item.text}</span>
                    </div>
                );
            })}
            {value.length > newArr.length && <span className={styles.moreBtn}>+{value.length - newArr.length}</span>}
        </div>
    );
}
